package com.example.demo.entrysData.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import com.example.demo.entrysData.model.EntrysDataEntity;
import com.example.demo.entrysData.model.EntrysDataGrouped;

@Repository
public interface EntrysDataRepository extends CrudRepository<EntrysDataEntity, Long> {
    Optional<EntrysDataEntity> findByloginIgnoreCase(String name);

    List<EntrysDataEntity> findByDepartmentId(long departmentId);

    Page<EntrysDataEntity> findByDepartmentId(long departmentId, Pageable pageable);

    Page<EntrysDataEntity> findAll(Pageable pageable);

    @Query("SELECT department_id, COUNT(id) AS count_id" +
    "FROM entrys_data" +
    "GROUP BY department_id" +
    "ORDER BY count_id DESC")
    List<EntrysDataGrouped> getCountEntrysInDepartment();
}
